import IORedis from "ioredis";
import { ConsumerOptions, StreamRecord } from './types/main';
export default class consumer {
    readLock: boolean;
    exitLoop: boolean;
    abandonLock: boolean;
    checkAbandonedMS: number;
    redisClient: IORedis.Redis;
    consumerName: string;
    groupName: string;
    readItems: number;
    blockIntervalMS: number;
    streamName: string;
    disableAbandonedCheck: boolean;
    recordHandler?: (streamRecord: StreamRecord) => Promise<void>;
    batchHandler?: (streamRecords: StreamRecord[]) => Promise<void>;
    errorHandler?: (streamRecord: StreamRecord, error: unknown) => Promise<void>;
    constructor(options: ConsumerOptions);
    /**
     * Builds {key: value} pairs out of the flat list obtained from stream
     */
    buildKVPairs(itemArray: any, isReclaimed: boolean): any;
    ackIDs(ids: string[]): Promise<void>;
    ackID(id: any): Promise<void>;
    readGroup(): Promise<void>;
    checkAbandoned(): Promise<void>;
    StartConsuming(): Promise<void>;
    /**
     * Gracefully stop consuming
     */
    StopConsuming(): Promise<void>;
}
