"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
var consumer = /** @class */ (function () {
    function consumer(options) {
        this.readLock = false;
        this.exitLoop = false;
        this.abandonLock = false;
        this.redisClient = options.redisClient;
        this.checkAbandonedMS = options.checkAbandonedMS || 1000;
        this.consumerName = options.consumerName;
        this.groupName = options.groupName;
        this.readItems = options.readItems;
        this.blockIntervalMS = options.blockIntervalMS || 0;
        this.streamName = options.streamName;
        this.disableAbandonedCheck = options.disableAbandonedCheck || false;
        this.recordHandler = options.recordHandler;
        this.batchHandler = options.batchHandler;
        this.errorHandler = options.errorHandler;
    }
    /**
     * Builds {key: value} pairs out of the flat list obtained from stream
     */
    consumer.prototype.buildKVPairs = function (itemArray, isReclaimed) {
        var retObj = {};
        retObj.recordID = itemArray[0];
        retObj.reclaimed = isReclaimed;
        for (var i = 0; i < itemArray[1].length; i += 2) {
            retObj[itemArray[1][i]] = itemArray[1][i + 1];
        }
        return retObj;
    };
    consumer.prototype.ackIDs = function (ids) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (ids.length === 0)
                            return [2 /*return*/];
                        return [4 /*yield*/, (_a = this.redisClient).xack.apply(_a, __spreadArray([this.streamName, this.groupName], ids))];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    consumer.prototype.ackID = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.redisClient.xack(this.streamName, this.groupName, id)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    consumer.prototype.readGroup = function () {
        return __awaiter(this, void 0, void 0, function () {
            var stream, items, ids, handledError, builtItems, _i, builtItems_1, record, error_1, error_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.readLock = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 18, , 19]);
                        return [4 /*yield*/, this.redisClient.xreadgroup('GROUP', this.groupName, this.consumerName, 'COUNT', this.readItems, 'BLOCK', this.blockIntervalMS, 'STREAMS', this.streamName, '>')];
                    case 2:
                        stream = _a.sent();
                        if (!(stream !== null && stream.length > 0)) return [3 /*break*/, 16];
                        items = stream[0][1];
                        ids = [];
                        handledError = false;
                        builtItems = items.map(function (item) { return _this.buildKVPairs(item, false); });
                        if (!this.batchHandler) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.batchHandler(builtItems)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!this.recordHandler) return [3 /*break*/, 13];
                        _i = 0, builtItems_1 = builtItems;
                        _a.label = 5;
                    case 5:
                        if (!(_i < builtItems_1.length)) return [3 /*break*/, 13];
                        record = builtItems_1[_i];
                        _a.label = 6;
                    case 6:
                        _a.trys.push([6, 8, , 12]);
                        return [4 /*yield*/, this.recordHandler(record)];
                    case 7:
                        _a.sent();
                        ids.push(record.recordID);
                        return [3 /*break*/, 12];
                    case 8:
                        error_1 = _a.sent();
                        handledError = true;
                        return [4 /*yield*/, this.ackIDs(ids)];
                    case 9:
                        _a.sent();
                        if (!this.errorHandler) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.errorHandler(record, error_1)];
                    case 10:
                        _a.sent();
                        _a.label = 11;
                    case 11: return [3 /*break*/, 13];
                    case 12:
                        _i++;
                        return [3 /*break*/, 5];
                    case 13:
                        if (!!handledError) return [3 /*break*/, 15];
                        return [4 /*yield*/, this.ackIDs(ids)];
                    case 14:
                        _a.sent();
                        _a.label = 15;
                    case 15:
                        this.readLock = false;
                        return [3 /*break*/, 17];
                    case 16:
                        this.readLock = false;
                        _a.label = 17;
                    case 17:
                        setTimeout(function () {
                            if (!_this.exitLoop) {
                                _this.readGroup();
                            }
                        }, 0);
                        return [3 /*break*/, 19];
                    case 18:
                        error_2 = _a.sent();
                        this.readLock = false;
                        return [3 /*break*/, 19];
                    case 19: return [2 /*return*/];
                }
            });
        });
    };
    consumer.prototype.checkAbandoned = function () {
        return __awaiter(this, void 0, void 0, function () {
            var stream, recoveryConsumers_1, error_3;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.abandonLock = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 7, , 8]);
                        return [4 /*yield*/, this.redisClient.xpending(this.streamName, this.groupName, '-', '+', this.readItems)];
                    case 2:
                        stream = _a.sent();
                        if (!(stream !== null && stream.length > 0)) return [3 /*break*/, 5];
                        recoveryConsumers_1 = {} // consumerName: ['ids']
                        ;
                        return [4 /*yield*/, Promise.all(stream.map(function (record) { return __awaiter(_this, void 0, void 0, function () {
                                var id, consumer, idleTime, deliveryAttempts;
                                return __generator(this, function (_a) {
                                    id = record[0];
                                    consumer = record[1];
                                    idleTime = record[2];
                                    deliveryAttempts = record[3] // we may want to use this later for a DLQ (or DLS I guess)
                                    ;
                                    if (idleTime > this.checkAbandonedMS) {
                                        if (!recoveryConsumers_1[consumer]) {
                                            recoveryConsumers_1[consumer] = [];
                                        }
                                        recoveryConsumers_1[consumer].push(id);
                                    }
                                    return [2 /*return*/];
                                });
                            }); }))];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(Object.keys(recoveryConsumers_1).map(function (consumer) { return __awaiter(_this, void 0, void 0, function () {
                                var claimed, ids, handledError, builtItems, _i, builtItems_2, record, error_4;
                                var _a;
                                var _this = this;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0: return [4 /*yield*/, (_a = this.redisClient).xclaim.apply(_a, __spreadArray([this.streamName, this.groupName, consumer, this.checkAbandonedMS], recoveryConsumers_1[consumer]))];
                                        case 1:
                                            claimed = _b.sent();
                                            if (!(claimed !== null && claimed.length > 0)) return [3 /*break*/, 14];
                                            ids = [];
                                            handledError = false;
                                            builtItems = claimed.map(function (item) { return _this.buildKVPairs(item, true); });
                                            if (!this.batchHandler) return [3 /*break*/, 3];
                                            return [4 /*yield*/, this.batchHandler(builtItems)];
                                        case 2:
                                            _b.sent();
                                            _b.label = 3;
                                        case 3:
                                            if (!this.recordHandler) return [3 /*break*/, 12];
                                            _i = 0, builtItems_2 = builtItems;
                                            _b.label = 4;
                                        case 4:
                                            if (!(_i < builtItems_2.length)) return [3 /*break*/, 12];
                                            record = builtItems_2[_i];
                                            _b.label = 5;
                                        case 5:
                                            _b.trys.push([5, 7, , 11]);
                                            return [4 /*yield*/, this.recordHandler(record)];
                                        case 6:
                                            _b.sent();
                                            ids.push(record.recordID);
                                            return [3 /*break*/, 11];
                                        case 7:
                                            error_4 = _b.sent();
                                            handledError = true;
                                            return [4 /*yield*/, this.ackIDs(ids)];
                                        case 8:
                                            _b.sent();
                                            if (!this.errorHandler) return [3 /*break*/, 10];
                                            return [4 /*yield*/, this.errorHandler(record, error_4)];
                                        case 9:
                                            _b.sent();
                                            _b.label = 10;
                                        case 10: return [3 /*break*/, 12];
                                        case 11:
                                            _i++;
                                            return [3 /*break*/, 4];
                                        case 12:
                                            if (!!handledError) return [3 /*break*/, 14];
                                            return [4 /*yield*/, this.ackIDs(ids)];
                                        case 13:
                                            _b.sent();
                                            _b.label = 14;
                                        case 14: return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 4:
                        _a.sent();
                        this.abandonLock = false;
                        return [3 /*break*/, 6];
                    case 5:
                        this.abandonLock = false;
                        _a.label = 6;
                    case 6:
                        setTimeout(function () {
                            if (!_this.exitLoop) {
                                _this.checkAbandoned();
                            }
                        }, this.checkAbandonedMS);
                        return [3 /*break*/, 8];
                    case 7:
                        error_3 = _a.sent();
                        this.abandonLock = false;
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    consumer.prototype.StartConsuming = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                setTimeout(function () {
                    _this.readGroup();
                }, 0);
                if (!this.disableAbandonedCheck) {
                    setTimeout(function () {
                        _this.checkAbandoned();
                    });
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Gracefully stop consuming
     */
    consumer.prototype.StopConsuming = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.exitLoop = true; // stop reading items
                        return [4 /*yield*/, new Promise(function (resolve) {
                                var inter = setInterval(function () {
                                    if (!_this.readLock && !_this.abandonLock) {
                                        resolve();
                                        clearInterval(inter);
                                    }
                                }, 100);
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return consumer;
}());
exports.default = consumer;
